<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'TOP LISTS
'This generates a list of the top selling
'products and the most recent items	
'-----------------------------------------------
'get useful application variables
numTopSellingProductsList = GetAppVar("topsellingproductslist")
numTopSellingProductsDays = GetAppVar("topsellingproductsdays")
numNewestProductsList = GetAppVar("newestproductslist")
numTopSellingProductsTruncate = GetAppVar("truncatetopsellingproducts")
numNewestProductsTruncate = GetAppVar("truncatenewestproducts")
numCacheTopSellingMins = GetAppVar("cachetopsellingmins")

'only build if at least one of the lists is visible
If (numTopSellingProductsList > 0) OR (numNewestProductsList > 0) then %>

	<div id="toplists"><%
		If numTopSellingProductsList > 0 then 
			'Check to see if we've got an application variable that matches the 
			'language we're on
			blnRefreshCache = true
			aryTopSelling = GetAppVar("aryTopSelling" & numLanguageID)
			datTimeTopSelling = GetAppVar("datTimeTopSelling" & numLanguageID)
			If IsDate(datTimeTopSelling) And IsArray(aryTopSelling) then 
				If DateAdd("n", numCacheTopSellingMins, datTimeTopSelling) > NowOffset Then
					blnRefreshCache = false
				End If				
			End If

 			If blnRefreshCache then
				
				'PULL OUT THE TOP TEN PRODUCT SALES
				'Note that for some reason in Access doing 
				'TOP X doesn't pull out the right amount all 
				'the time, hence the additional loop check
				datFirstDate = IIf(numTopSellingProductsDays = 0, "1/1/1990 00:00", DateAdd("d", -numTopSellingProductsDays, NowOffset))
		        strOrderBySQL = IIf(strDatabaseType = "mysql", "ProductHits", "SUM(tblCactuShop" & TABLE_PREFIX & "InvoiceRows.IR_Quantity)")
                strQuery=LimitSQL("SUM(tblCactuShop" & TABLE_PREFIX & "InvoiceRows.IR_Quantity) AS ProductHits,tblCactuShop" & TABLE_PREFIX & "Products.P_ID,tblCactuShop" & TABLE_PREFIX & "Products.P_Name" & numLanguageID & " " & _
                    "FROM (((((tblCactuShop" & TABLE_PREFIX & "Orders INNER JOIN tblCactuShop" & TABLE_PREFIX & "InvoiceRows ON tblCactuShop" & TABLE_PREFIX & "Orders.O_ID=tblCactuShop" & TABLE_PREFIX & "InvoiceRows.IR_OrderNumberID) " & _
                    "INNER JOIN tblCactuShop" & TABLE_PREFIX & "Versions ON tblCactuShop" & TABLE_PREFIX & "InvoiceRows.IR_VersionCode=tblCactuShop" & TABLE_PREFIX & "Versions.V_CodeNumber) " & _
                    "INNER JOIN tblCactuShop" & TABLE_PREFIX & "Products ON tblCactuShop" & TABLE_PREFIX & "Versions.V_ProductID = tblCactuShop" & TABLE_PREFIX & "Products.P_ID) " & _
                    "INNER JOIN tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink ON tblCactuShop" & TABLE_PREFIX & "Products.P_ID = tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_ProductID) " & _
                    "INNER JOIN tblCactuShop" & TABLE_PREFIX & "Categories ON tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_CategoryID = tblCactuShop" & TABLE_PREFIX & "Categories.CAT_ID) " & _
                    "LEFT OUTER JOIN tblCactuShop" & TABLE_PREFIX & "Suppliers ON tblCactuShop" & TABLE_PREFIX & "Products.P_SupplierID = tblCactuShop" & TABLE_PREFIX & "Suppliers.SUP_ID  " & _
                    "WHERE tblCactuShop" & TABLE_PREFIX & "Products.P_Name" & numLanguageID & " <> '' AND tblCactuShop" & TABLE_PREFIX & "Products.P_Live = 'y' AND P_CustomerGroupID IN (0," & DB_CG_ID & ") " & _
                    "AND tblCactuShop" & TABLE_PREFIX & "Orders.O_Date >= " & strDateDelimiter & ReverseDate(datFirstDate) & strDateDelimiter & " AND V_Live ='y' " & _
                    "AND CAT_Live = 'y' AND V_CustomerGroupID IN (0," & DB_CG_ID & ") AND CAT_CustomerGroupID IN (0," & DB_CG_ID & ") " & _
                    "AND (SUP_Live <> 'n' OR SUP_Live IS NULL) GROUP BY tblCactuShop" & TABLE_PREFIX & "Products.P_ID, tblCactuShop" & TABLE_PREFIX & "Products.P_Name" & numLanguageID & " " & _
                    "ORDER BY " & strOrderBySQL & " DESC", numTopSellingProductsList, true)

				Call ExecuteRS(strQuery, objRecordSet)
				numTotalTopSelling = objRecordSet.RecordCount
				numTopSellingCount = 0
				ReDim aryTopSelling(numTotalTopSelling, 1)
				if not (objRecordSet.BOF And objRecordSet.EOF) then 
					Do While not objRecordSet.EOF and numCount < numTopSellingProductsList
						numCount = numCount + 1
						aryTopSelling(numTopSellingCount, 0) = objRecordSet("P_ID") & ""
						aryTopSelling(numTopSellingCount, 1) = objRecordSet("P_Name" & CInt(numLanguageID)) & ""
						If numTopSellingProductsTruncate > 0 then 
							if len(aryTopSelling(numTopSellingCount, 1)) > numTopSellingProductsTruncate then aryTopSelling(numTopSellingCount, 1) = left(aryTopSelling(numTopSellingCount, 1), numTopSellingProductsTruncate - 3) & "..."
						End If
						numTopSellingCount = numTopSellingCount + 1
						objRecordSet.MoveNext
					Loop
				End If
				objRecordSet.Close
			
				'Save to language-specific application array 
				Call SetAppVar("aryTopSelling" & numLanguageID, aryTopSelling)
				Call SetAppVar("datTimeTopSelling" & numLanguageID, NowOffset)

			End If
			
			'Loop through array if we've got one and display
			If IsArray(aryTopSelling) Then 
				If UBound(aryTopSelling, 1) > 0 then %>
					<div class="box">
						<h4><% WriteString("ContentText_TopSellerList") %></h4>
						<div class="pad">
							<div><ul><%
							For i = 0 to UBound(aryTopSelling, 1)
								If i < numTopSellingProductsList and aryTopSelling(i, 0) <> "" then %>
								<li><div><a href="product.asp?<%= objCactuSession.QS %>P_ID=<%= aryTopSelling(i, 0) %>"><%= aryTopSelling(i, 1) %></a></div></li>
								<% End If
							Next %>
							</ul></div>
						</div>
					</div><%
				End If
			end if
		End If
		
		If numNewestProductsList > 0 then
			'-----------------------------------------------
			'PULL OUT THE TOP TEN NEWEST PRODUCTS
			'-----------------------------------------------
			numCount = 0
			strQuery = LimitSQL("tblCactuShop" & TABLE_PREFIX & "Products.P_ID, tblCactuShop" & TABLE_PREFIX & "Products.P_Name" & numLanguageID & " FROM (((tblCactuShop" & TABLE_PREFIX & "Versions INNER JOIN tblCactuShop" & TABLE_PREFIX & "Products ON tblCactuShop" & TABLE_PREFIX & "Versions.V_ProductID = tblCactuShop" & TABLE_PREFIX & "Products.P_ID) INNER JOIN tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink ON tblCactuShop" & TABLE_PREFIX & "Products.P_ID = tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_ProductID) INNER JOIN tblCactuShop" & TABLE_PREFIX & "Categories ON tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_CategoryID = tblCactuShop" & TABLE_PREFIX & "Categories.CAT_ID) LEFT OUTER JOIN tblCactuShop" & TABLE_PREFIX & "Suppliers ON tblCactuShop" & TABLE_PREFIX & "Products.P_SupplierID = tblCactuShop" & TABLE_PREFIX & "Suppliers.SUP_ID WHERE P_Name" & CInt(numLanguageID)  & " <> '' AND V_Live ='y' AND P_Live = 'y' AND CAT_Live = 'y' AND V_CustomerGroupID IN (0," & DB_CG_ID & ") AND P_CustomerGroupID IN (0," & DB_CG_ID & ") AND CAT_CustomerGroupID IN (0," & DB_CG_ID & ") AND (SUP_Live <> 'n' OR SUP_Live IS NULL) ORDER BY P_ID DESC", numNewestProductsList, true)
			Call ExecuteRS(strQuery, objRecordSet)
			if Not (objRecordSet.BOF And objRecordSet.EOF) then
				'Run it in to an array: bound 0 is ID, 1 is name of product %>
				<div class="box">
					<h4><% WriteString("ContentText_NewProductsList") %></h4>
					<div class="pad">
					<div><ul><% 
						Do While not objRecordSet.EOF and numCount < numNewestProductsList
							numCount = numCount + 1
							numProductID = objRecordSet("P_ID")
							numProductName = objRecordSet("P_Name" & CInt(numLanguageID))
							If numNewestProductsTruncate > 0 then 
								if len(numProductName) > numNewestProductsTruncate then numProductName = left(numProductName, numNewestProductsTruncate - 3) & "..."
							End If %>				
							<li><div><a href="product.asp?<%= objCactuSession.QS %>P_ID=<%= numProductID %>"><%= numProductName %></a></div></li><% 
							objRecordSet.MoveNext
						Loop %>
					</ul></div>
				</div></div>
			<% end if
			objRecordSet.Close
		end if %>
	</div>
	<%
end if %>


