<!-- #include file="functions_pro.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'FUNCTIONS THAT ARE REQUIRED ON MANY PAGES		
'OK, maybe some SUBS too...						
'-----------------------------------------------

'***********************************************
'-SAFE PROCEDURES
'These functions check the validity of data.
'This is to ensure incoming variables are what
'we expect.
'***********************************************

'-----------------------------------------------
'SQLSafe - doubles up apostrophes
'-----------------------------------------------
Function SQLSafe(strText)
	SQLSafe = Replace(strText, "'", "''")
End Function

'-----------------------------------------------
'NUMSAFE - makes sure a number is a valid double
'-----------------------------------------------
Public Function NumSafe(objNumber)
	If isnull(objNumber) then
		NumSafe = 0
	ElseIf not isnumeric(objNumber) or objNumber = "" then 
		NumSafe = 0
	else 
		If objNumber > -9223372036854775808 and objNumber < 9223372036854775807 then
			NumSafe = Cdbl(objNumber)
		Else
			NumSafe = 0
		End If		
	End If
End Function

'-----------------------------------------------
'SQLDECIMALS - ensures that commas used for
'decimal separators on non-English Windows are
'replaced with points prior to submission to DB
'(otherwise they look like field separators).
'-----------------------------------------------
Public Function SQLDecimals(numNumber)
	If isnull(numNumber) then
		SQLDecimals = "0"
	ElseIf InStr(Cstr(numNumber), ",") > 1 then
		SQLDecimals = replace(Cstr(numNumber), ",", ".")
	Else
		SQLDecimals = Cstr(numNumber)
	End If
End Function

'-----------------------------------------------
'FILENAMESAFE - strips out any characters which 
'aren't allowed in windows-based file names
'-----------------------------------------------
Function FileNameSafe(strFileName)
	aryRemove = Array(" ", "'", ",", """", "/", "\", ":", "*", "?", "<", ">", "|", "(", ")", "%")
	aryReplace = Array("-", "", "-", "", "", "", "", "", "", "", "", "", "", "", "pc")
	FileNameSafe = strFileName
	Dim numCount
	For numCount = 0 to ubound(aryRemove)
		FileNameSafe = Replace(FileNameSafe, aryRemove(numCount), aryReplace(numCount))
	Next
End Function

'-----------------------------------------------
'WRITESAFE - ensures against XSS attacks - all
'outgoing variables ar writesafed first.
'-----------------------------------------------
Public Function WriteSafe(strValue)
	If strValue <> "" and not IsNull(strValue) then
		WriteSafe = Server.HTMLEncode(strValue)
		WriteSafe = replace(WriteSafe, "'", "&#39;")
	End if
End Function

'-----------------------------------------------
'URLSAFE - ensures against XSS attacks in urls
'-----------------------------------------------
Public Function URLSafe(strValue)
	If strValue <> "" and not IsNull(strValue) then
		URLSafe = server.URLEncode(strValue)
	End if
End Function

'-----------------------------------------------
'LISTSAFE - checks a value is part of a comma-
'seperated list of allowed values
'-----------------------------------------------
Function ListSafe(strValue, strAllowedValues, strDefaultValue)
	If IsNull(strValue) then strValue = ""
	If IsNull(strAllowedValues) then strAllowedValues = ""
	If IsNull(strDefaultValue) then strDefaultValue = ""

	If Contains(strAllowedValues, strValue) then
		ListSafe = strValue
	Else
		ListSafe = strDefaultValue
	End If
End Function
'***********************************************




'***********************************************
'GENERAL-USE PROCEDURES
'***********************************************

'-----------------------------------------------
'CastSQL - cast the string if its Ntext in MSSQL
'-----------------------------------------------
Function CastSQL(strText)
	if strDatabaseType = "mssql" then CastSQL = "cast(" & strText & " as nvarchar(4000))" else CastSQL = strText
End Function


'-----------------------------------------------
'SAFE ROUND
'For some reason, the round function doesn't
'round 0.5 correctly.
'-----------------------------------------------
Public Function SafeRound(numValue, numDecimalPlaces)
	SafeRound = Round(NumSafe(numValue) + 0.00001, numDecimalPlaces)
End Function

'Same as above, but for negative numbers
Public Function NegSafeRound(numValue, numDecimalPlaces)
	NegSafeRound = Round(NumSafe(numValue) - 0.00001, numDecimalPlaces)
End Function
	

'-----------------------------------------------
'IIF FUNCTION
'This is a really useful function to keep code
'nice and clean. If the clause is true,
'it returns the first value, otherwise it returns
'the second.
'-----------------------------------------------
Public Function IIf(blnWhichOne, objTruePart, objFalsePart)
	If blnWhichOne then 
		IIf = objTruePart 
	Else 
		IIf = objFalsePart
	End If
End Function


'-----------------------------------------------
'OCCURRENCES
'Returns the number of times a string appears in
'another string
'-----------------------------------------------
Function Occurrences(str1, str2)
	Occurrences = Len(Replace(str1, str2, str2 & " ")) - Len(str1)
End Function

'-----------------------------------------------
'MAX/MIN
'Returns the bigger/smaller of two numbers
'-----------------------------------------------
Function Max(num1, num2)
	Max = IIf(num2 > num1, num2, num1)
End Function
Function Min(num1, num2)
	Min = IIf(num2 < num1, num2, num1)
End Function

'-----------------------------------------------
'GET RANDOM STRING
'This function returns a random alpha-numeric
'string, of length 'numLength' (passed).
'-----------------------------------------------
Function GetRandomString(numLength)
	'Generate a new seed based on the server timer
	Randomize
	strRandomString = ""
	
	'Loop for as many letters as we need
	Do while len(strRandomString) < numLength
		'Generate random number	
		numRandomNumber = int(rnd(1) * 36) + 1
		if numRandomNumber < 11 then
			'If it's less than 11 then we'll do a number
			strRandomString = strRandomString & chr(numRandomNumber + 47)
		else
			'Otherwise we'll do a letter; + 86 because 96 (min being 97, 'a') - 10 (the first 10 was for the number)
			strRandomString = strRandomString & chr(numRandomNumber + 86)
		end if
	loop

	'Zero and 'o' and '1' and 'I' are easily confused...
	'So we replace any of these with alternatives
	'To ensure best randomness, replace the numbers
	'with alternative letters and letters
	'with alternative numbers

	strRandomString = replace(strRandomString, "0", "X")
	strRandomString = replace(strRandomString, "1", "Y")
	strRandomString = replace(strRandomString, "O", "4")
	strRandomString = replace(strRandomString, "I", "9")

	GetRandomString = strRandomString
End Function


'-----------------------------------------------
'FORMAT DATE IN REVERSE FORMAT					
'e.g. 2000/12/1 for 1st December 2000. This way	
'works (or should work) in all language formats	
'and in the US or UK where standard numerical	
'dates are written MM/DD/YYYY or DD/MM/YYYY.	
'You wouldn't believe how many problems dates	
'cause...										
'-----------------------------------------------
Function ReverseDate(datDateTime)
	If IsNull(datDateTime) then 
		ReverseDate = ""
	elseif CStr(datDatetime) = "" then
		ReverseDate = ""
	else
		strDatabaseFormat = GetAppVar("databasedateformat")
		ReverseDate = FormatDate(datDateTime, strDatabaseFormat)
	end if
End Function

'-----------------------------------------------
'PARSE AND HANDLE DYNAMIC TAGS, i.e. SESSION
'The cookieless sessions feature in CactuShop
'allows the session state ID to be passed around
'the store in form fields and querystrings as
'well as backed-up on a cookie (depending on the
'usecookies config setting). To ensure this
'querystring can be included in URLs that are
'added manually to news items, language strings
'product descriptions and other places, we have
'this function. It will parse a text script and
'find/replace occurences of the following tags
'with the appropriate content:

'xxxWEBSHOPURLxxx
'xxxWEBSHOPFOLDERxxx
'xxxTEMPLATEIMAGESxxx
'xxxSESSIONQSxxx
'-----------------------------------------------
Function HandleDynamicTagsInContent(strValue)
	strValue = Replace(strValue & "", "xxxWEBSHOPURLxxx", GetAppVar("webshopurl"))
	strValue = Replace(strValue & "", "xxxWEBSHOPFOLDERxxx", strTemplateShopFolder)
	strValue = Replace(strValue & "", "xxxTEMPLATEIMAGESxxx", strTemplateImagesFolder)
	strValue = Replace(strValue & "", "xxxSESSIONQSxxx", objCactuSession.QS)
	HandleDynamicTagsInContent = strValue
End Function

'-----------------------------------------------
'ROT - obfuscates data.
'-----------------------------------------------
Function Rot(strValue)
	For numCount = 1 To len(strValue)
		numChar = Asc(mid(strValue, numCount, 1))
		If numChar >= 48 And numChar <= 125 Then
			numChar = numChar + 39
	    	If numChar > 125 Then
			numChar = numChar - 78
			End If
		End If
	    Rot = (Rot & ChrW(numChar))
	Next
End Function

'-----------------------------------------------
'FORMAT DATE
'Formats a date to a specific format. Supports
'the following codes. A '0' means it has leading zeros
'and a 'a' means it's abbreviated
'
'[m] [m0]		month number
'[mn] [mna]		month name
'[d] [da]		day of the month with leading number
'[w], [wa]		Weekday name
'[24h], [24h0]	hour in 24 hour clock
'[h], [h0]		hour in 12 hour clock
'[n], [n0]		minutes 
'[s], [s0]		seconds
'[yy]			year (two digits)
'[yyyy]			year (four digits)
'[a]			AM or PM
'
'This is a replacement for the old 'friendlydate'
'-----------------------------------------------
Function FormatDate(datValue, strDateFormat)
	'Take a copy of the format
	strFormat = strDateFormat
	
	'Check date is valid
	If not isDate(datValue) then
		FormatDate = ""
		Exit Function
	End If
	
	'Set all variables
	numMonth = Month(datValue)
	strMonthZero = AddLeadingZero(numMonth)
	numDay = Day(datValue)
	strDayZero = AddLeadingZero(numDay)
	num24Hour = Hour(datValue)
	str24HourZero = AddLeadingZero(num24Hour)
	numHour = IIf(num24Hour <= 12, num24Hour, num24Hour - 12)
	strHourZero = AddLeadingZero(numHour)
	numMinutes = Minute(datValue)
	strMinutesZero = AddLeadingZero(numMinutes)
	numSeconds = Second(datValue)
	strSecondsZero = AddLeadingZero(numSeconds)
	strYear4 = Year(datValue)
	strYear2 = right(strYear4, 2)
	strAMPM = IIf(num24Hour >= 12, "PM", "AM")
	
	'We check we need these before calling them. That's because
	'they require language strings, and in some cases language
	'strings don't exist yet (like in the session.asp)
	If instr(strDateFormat, "[mn") > 0 then
		strMonthName = GetMonthName(datValue, false)
		strMonthNameAbbr = GetMonthName(datValue, true)
	end if
	If instr(strDateFormat, "[w") > 0 then
		strWeekday = GetWeekDay(datValue, false)
		strWeekDayAbbr = GetWeekday(datValue, true)
	end if
	
	'Now do the replacements
	strFormat = Replace(strFormat, "[m]", numMonth)
	strFormat = Replace(strFormat, "[m0]", strMonthZero)
	strFormat = Replace(strFormat, "[mn]", strMonthName)
	strFormat = Replace(strFormat, "[mna]", strMonthNameAbbr)
	strFormat = Replace(strFormat, "[d]", numDay)
	strFormat = Replace(strFormat, "[da]", strDayZero)
	strFormat = Replace(strFormat, "[w]", strWeekday)
	strFormat = Replace(strFormat, "[wa]", strWeekDayAbbr)
	strFormat = Replace(strFormat, "[24h]", num24Hour)
	strFormat = Replace(strFormat, "[24h0]", str24HourZero)
	strFormat = Replace(strFormat, "[h]", numHour)
	strFormat = Replace(strFormat, "[h0]", strHourZero)
	strFormat = Replace(strFormat, "[n]", numMinutes)
	strFormat = Replace(strFormat, "[n0]", strMinutesZero)
	strFormat = Replace(strFormat, "[s]", numSeconds)
	strFormat = Replace(strFormat, "[s0]", strSecondsZero)
	strFormat = Replace(strFormat, "[yy]", strYear2)
	strFormat = Replace(strFormat, "[yyyy]", strYear4)
	strFormat = Replace(strFormat, "[a]", strAMPM)
	FormatDate = strFormat
End Function

'Used above to suffix a 0 at the start of 2 digit numbers.
Function AddLeadingZero(strValue)
	If len(CStr(strValue)) = 1 then
		AddLeadingZero = "0" & strValue
	Else
		AddLeadingZero = strValue
	End If 
End Function

'Function to return the translation of the weekday. Optional
'abbreviation. LS 1215-1221, 1516-1523
Function GetWeekDay(datValue, blnAbbreviate)
	GetWeekDay = GetString("WeekDay_" & WeekdayName(Weekday(datValue)) & IIf(blnAbbreviate, "_Abbr", ""))
End Function

'Same as the abbove, but for months LS 1523-1546
Function GetMonthName(datValue, blnAbbreviate)
	GetMonthName = GetString("Month_" & MonthName(Month(datValue)) & IIf(blnAbbreviate, "_Abbr", ""))
End Function

'-----------------------------------------------
'NOW OFFSET
'-----------------------------------------------
'A 'now' replacement, to return the current time + an
'hourly offset. Should be used everywhere in the
'code instead of Now(), Date() and Time()
Function NowOffset()
	NowOffset = DateAdd("h", GetAppVar("timeoffset"), now)
End Function


'-----------------------------------------------
'SEND MAIL FUNCTION								
'General use send email function. Supports aspmail,
'persits ASPEmail, CDO, CDOSys, and jmail, and 
'has two debug modes (write and off).
'-----------------------------------------------
Sub SendEMail(strEmailMethod, strMailServer, strToAddress, strCCAddress, strBCCAddress, strFromAddress, strFromName, strReplyAddress, strReplyName, strSubjectLine, strBodyText, strAttachmentPath, blnHTML)

	'If we're attaching a file, check it here
	If strAttachmentPath <> "" then
		set objFileSystem = CreateObject("Scripting.FileSystemObject")
		If objFileSystem.FileExists(strAttachmentPath) then
			aryTempPathSplit = split(strAttachmentPath, "\")
			numLastChunk = Ubound(aryTempPathSplit)
			strAttachmentFileName = aryTempPathSplit(numLastChunk)
		Else
			strAttachmentPath = ""
		End if
		set objFileSystem = Nothing
	End if

	'Send the email!
	Select Case lcase(strEmailMethod)

		Case "aspmail"
			Set objMail = Server.CreateObject("SMTPsvg.Mailer")
			objMail.RemoteHost  = strMailServer
			objMail.FromName    = strFromName
			objMail.FromAddress = strFromAddress
			objMail.AddRecipient strToAddress, strToAddress
			If strCCAddress <> "" then objMail.AddCC strCCAddress, strCCAddress
			If strBCCAddress <> "" then objMail.AddBCC strBCCAddress, strBCCAddress
			if blnHTML then 
				objMail.ContentType = "text/html"
			else
				objMail.ContentType = "text/plain"
			end if
			objMail.Subject = strSubjectLine

			'NO SMTP AUTHENTICATION SUPPORT!!!

			objMail.BodyText = strBodyText
			If strAttachmentPath <> "" then
				objMail.AddAttachment(strAttachmentPath)
			End if
			If not objMail.SendMail then
				'If the mail send fails, code can go here
				'to handle it
			end if
			Set objMail = Nothing
			
		Case "persits", "aspemail"
			Set objMail = Server.CreateObject("Persits.MailSender") 
			objMail.Host = strMailServer
			objMail.AddAddress strToAddress
			If strBCCAddress <> "" then objMail.AddBCC strBCCAddress
			If strCCAddress <> "" then objMail.AddCC strCCAddress
			objMail.IsHTML = blnHTML
			objMail.From = strFromAddress
			objMail.FromName = strFromName
			objMail.Subject = strSubjectLine

			'Handle SMTP authentication
			If GetAppVar("smtpauthusername") <> "" then 'need authentication
				objMail.Username = GetAppVar("smtpauthusername")
				objMail.Password = GetAppVar("smtpauthpassword")
			End if

			objMail.Body = strBodyText
			If strAttachmentPath <> "" then
				objMail.AddAttachment(strAttachmentPath)
			End if 
			objMail.Send
			Set objMail = Nothing

		Case "cdo", "cdonts"
			Set objMail = Server.CreateObject("CDONTS.NewMail")
			objMail.To = strToAddress
			If strCCAddress <> "" then objMail.CC = strCCAddress
			If strBCCAddress <> "" then objMail.BCC = strBCCAddress
			objMail.From = strFromAddress
			objMail.Value("Reply-To") = strReplyAddress
			If blnHTML then
				objMail.BodyFormat = 0 
				objMail.MailFormat = 0 
			end if
			objMail.Subject = strSubjectLine

			'NO SMTP AUTHENTICATION SUPPORT!!!

			objMail.Body = strBodyText
			If strAttachmentPath <> "" then
				objMail.AttachFile strAttachmentPath, strAttachmentFileName
			End if
			objMail.Send
			Set objMail = Nothing

		case "cdosys" 
			'CDOSYS is the successor to CDONTS, used on Windows Server 2003 and later
			
			'Create the CDOSYS objects
			Set objCDOSYSMail = Server.CreateObject("CDO.Message")
			Set objCDOSYSCon = Server.CreateObject("CDO.Configuration")
			
			'Set configuration settings
			objCDOSYSCon.Fields("http://schemas.microsoft.com/cdo/configuration/smtpserverport")  = GetAppVar("smtpportnumber")
			
			If strMailServer <> "" then
				'if a mail server is set, use that
				objCDOSYSCon.Fields("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2
				objCDOSYSCon.Fields("http://schemas.microsoft.com/cdo/configuration/smtpserver") = strMailServer
			else
				'otherwise use the local SMTP service pickup directory
				objCDOSYSCon.Fields("http://schemas.microsoft.com/cdo/configuration/sendusing") = 1
			end if

			'Handle SMTP authentication
			If GetAppVar("smtpauthusername") <> "" then 'need authentication
				objCDOSYSCon.Fields("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1 'set auth ON
				objCDOSYSCon.Fields("http://schemas.microsoft.com/cdo/configuration/sendusername") = GetAppVar("smtpauthusername")
				objCDOSYSCon.Fields("http://schemas.microsoft.com/cdo/configuration/sendpassword") = GetAppVar("smtpauthpassword")
			End if

			'Set the configuration of the message
			objCDOSYSCon.Fields.Update
			Set objCDOSYSMail.Configuration = objCDOSYSCon
			Set objCDOSYSCon = nothing
			
			'Set settings and send the email 
			With objCDOSYSMail
				.From = strFromAddress
				.To = strToAddress
				.Subject = strSubjectLine
				.ReplyTo = strReplyAddress
				If strCCAddress <> "" then .CC = strCCAddress
				If strBCCAddress <> "" then .BCC  = strBCCAddress
				If blnHTML then .HTMLBody = strBodyText else .TextBody = strBodyText
				If strAttachmentPath <> "" then objCDOSYSmail.AddAttachment strAttachmentPath
				.Send
			End With
			
			'Destroy mailing object
			Set objCDOSYSMail = nothing
		
		Case "jmail"
			set objMail = Server.CreateObject("JMail.Message")
			objMail.From = strFromAddress
			objMail.FromName = strFromName
			objMail.Subject = strSubjectLine

			'Handle SMTP authentication
			If GetAppVar("smtpauthusername") <> "" then 'need authentication
				objMail.MailServerUserName = GetAppVar("smtpauthusername")
				objMail.MailServerPassWord = GetAppVar("smtpauthpassword")
			End if

			objMail.AddRecipient strToAddress
			If strAttachmentPath <> "" then
				objMail.AddAttachment strAttachmentPath
			else
				if blnHTML then 
					objMail.ContentType = "text/html"
				else
					objMail.ContentType = "text/plain"
				end if
			End if
			objMail.Body = strBodyText
			objMail.Send(strMailServer)
			set objMail = Nothing
		
		Case "write" 
			'useful for development/testing
			response.write("<span class=""bold""><a href=""" & GetRedirect("emailonscreen") & """>INFO: Why am I seeing emails written to the screen?</a></span><br /><br />")
			response.write("mailto: " & strToAddress & "<br />")
			response.write("from: " & strFromAddress & "<br />")
			response.write("subject: " & strSubjectLine & "<br />")
			response.write("smtp port#: " & GetAppVar("smtpportnumber") & "<br />")
			response.write("smtp auth username: " & GetAppVar("smtpauthusername") & "<br />")
			response.write("smtp auth password: " & GetAppVar("smtpauthpassword") & "<br />")
			response.write("format: " & IIf(blnHTML, "HTML", "Plain Text") & "<br />")
			if strAttachmentPath <> "" then
				response.write("attachment: " & strAttachmentPath & "<br />")
			end if
			response.write("<textarea cols=""60"" rows=""20"">" & strBodyText & "</textarea><br />")

		Case Else
			'JUST DO NOTHING
			'This is way of disabling mail sends totally, again, useful for debugging
			'If you suspect the mail send is throwing an error, disable mail and
			'try again - if it clears your problem, pretty fair bet the mail send is
			'responsible.
			
	End Select
End Sub

'-----------------------------------------------
'ADD VALUE TO URL
'Adds a name/value pair to the querystring or a
'url
'-----------------------------------------------
Function AddValueToURL(strURL, strNameAndValue)
	If instr(strURL, "?") = 0 then
		AddValueToURL = strURL & "?" & strNameAndValue
	Else
		AddValueToURL = strURL & "&amp;" & strNameAndValue
	End If
End Function


'-----------------------------------------------
'BUILD SINGLE DROPDOWN MENUS					
'Just a bit of code that generates a dropdown	
'menu based on the open recordset and other		
'details passed to it. Will also check what		
'option is selected.							
'-----------------------------------------------
Sub SingleDropDown(strDropdownName, strFirstLineValue, strFirstLineDisplay, objRS, strValueName, strDisplayName, strSelectedVariable)
	'Start the select
	strMenuText = ""
	strMenuText = "<select name=""" & strDropdownName & """ id=""" & strDropdownName & """ size=""1"">" & vbcrlf
	
	'Add in first line if reqd.
	If strFirstLineDisplay <> "" then
		strMenuText = (strMenuText & "<option value=" & """" & WriteSafe(strFirstLineValue) & """" & ">" & WriteSafe(strFirstLineDisplay) & "</option>" & vbcrlf)
	end if
	
	'Loop through recordset and add in the options
	do while not objRS.EOF
		strValue = objRS(strValueName) & ""
		strName = objRS(strDisplayName) & ""

		If IsNull(strValue) then strValue = ""
		If IsNull(strName) then strName = ""
		If IsNull(strSelectedVariable) then strSelectedVariable = ""

		strSelected = IIf(CStr(strSelectedVariable) = CStr(strValue), " selected=""selected""", "")
		strMenuText = (strMenuText & "<option" & strSelected & " value=""" & WriteSafe(strValue) & """>" & WriteSafe(strName) & "</option>" & vbcrlf)
		objRS.movenext
	loop
	
	'Close and write out
	strMenuText = strMenuText & "</select>"
	response.write(strMenuText)
End Sub


'-----------------------------------------------
'QUOTE MARK HANDLER
'Ok, when we create the Javascript popup links,
'there is a problem in IE. Even if you try to 
'HTMLencode or URLencode the item names, this
'isn't enough to stop IE throwing an annoying
'Javascript error when you click on the link to
'launch a large view. Therefore, we have to
'manually create this special function to
'replace ' and " with something IE won't object
'to and then switch them back later. BTW, 
'strCallMode is '1' to encode and '2' to decode.
'-----------------------------------------------
Function JavascriptPopupEncode(strLink, strCallMode)
	If strCallMode = 1 then
		JavascriptPopupEncode = replace(strLink, "'", "apostrophemark")
		JavascriptPopupEncode = replace(JavascriptPopupEncode, """", "doublequotemark")
	Else
		JavascriptPopupEncode = replace(strLink, "apostrophemark", "'")
		JavascriptPopupEncode = replace(JavascriptPopupEncode, "doublequotemark", """")
	End if
End Function


'-----------------------------------------------
'LIMIT SQL
'Adds in the 'limit' part of a query - either the
'TOP X in mssql/access, or LIMIT 0, X for mysql
'-----------------------------------------------
Function LimitSQL(strQuery, numLimit, blnDistinct)
	strDistinct = IIf(blnDistinct, "DISTINCT ", "")
	If numLimit = -1 then
		LimitSQL = "SELECT " & strDistinct & strQuery
	ElseIf strDatabaseType = "mysql" then
		LimitSQL = "SELECT " & strDistinct & strQuery & " LIMIT 0, " & CStr(numLimit)
	Else
		LimitSQL = "SELECT " & strDistinct & "TOP " & CStr(numLimit) & " " & strQuery
	End If
End Function



'-----------------------------------------------
'GET A FILE LOCATION
'Accepts Location Folder, FileName, Array of
'File Types and a FSO. If a file is found,
'returns the file name, else returns an emtpy
'string
'-----------------------------------------------
Function GetFileLocation(strPath, strName, aryFileTypes, objFileSystem)
	GetFileLocation = ""
	If IsArray(aryFileTypes) Then
		For numCount = 0 To UBound(aryFileTypes)			
			If objFileSystem.FileExists(strPath & "\" & strName & "." & aryFileTypes(numCount)) Then
				GetFileLocation = strName & "." & aryFileTypes(numCount)
				Exit For
			End If
		Next
	End If
End Function

'-----------------------------------------------
'CONTAINS
'Checks to see if a value is contained in a
'comma-seperated list of values
'-----------------------------------------------
Function Contains(strCommaValues, strValue)
	Contains = InStr("," & strCommaValues & ",", "," & strValue & ",") > 0
End Function

'-----------------------------------------------
'DUAL REQUEST
'Checks the form value first - if that is blank
'it gets it from the querystring
'-----------------------------------------------
Function DualRequest(strValue)
	DualRequest = request.Form(strValue)
	If DualRequest = "" then 
		DualRequest = request.QueryString(strValue)
	End If
End Function

'-----------------------------------------------
'GET APP VAR
'Returns an application variable
'-----------------------------------------------
Function GetAppVar(strName)
	GetAppVar = Application(LICENSENUMBER & strName)
End Function

'-----------------------------------------------
'SET APP VAR
'Sets an application variable
'-----------------------------------------------
Sub SetAppVar(strName, strValue)
	Application(LICENSENUMBER & strName) = strValue
End Sub

'***********************************************


'***********************************************
'SEARCH-RELATED FUNCTIONS
'***********************************************
'-----------------------------------------------
'HIGHLIGHT KEYWORDS
'This is used in the search forms to highlight
'the keywords that are being searched. The string,
'a comma-delimited list of keywords and the css
'tag to replace the words are passed, and the 
'highlighted text is returned.
'-----------------------------------------------
Function Highlight(strBaseText, aryKeywords)
	Highlight = strBaseText
	If IsArray(aryKeywords) then 
		for each strKeyword in aryKeywords
			If not strKeyword = "" then 
				'Instead of using replace, this code keeps the original text (that way we keep the case of the word)
				'We mark the front and back of the search term with chr(1) and (2), then replace with span tags later
				numLastSearchPosition = 1
				do while InStr(numLastSearchPosition, lcase(Highlight), lcase(strKeyword)) > 0
					numFoundPlace = instr(numLastSearchPosition, lcase(Highlight), lcase(strKeyword))
					Highlight = (left(Highlight, numFoundPlace - 1) & chr(1) & mid(Highlight, numFoundPlace, len(strKeyword)) & chr(2) & mid(Highlight, numFoundPlace + len(strKeyword)))
					numLastSearchPosition = numFoundPlace + len(strKeyword) + 1
				loop
			end if
		next
		'now replace the dummy characters with the span
		Highlight = Highlight & " "
		Highlight = Replace(Highlight, chr(1), "<em class=""highlight"">")
		Highlight = Replace(Highlight, chr(2), "</em>")
	End If
End Function

'-----------------------------------------------
'CLEAN KEYWORDS
'Cleans up a phrase entered by the user so it's
'ready for parsing.
'-----------------------------------------------
Function CleanSearchKeywords(strKeywords, strSearchCriteria)
	
	'Make a local copy
	strNewKeywords = strKeywords
	
	'Replace characters from removal array with a space
	aryRemove = Array(",", ";", "%", "_", "[", "]")
	For numCount = 0 to ubound(aryRemove)
		strNewKeywords = Replace(strNewKeywords, aryRemove(numCount), " ")
	Next
	
	'Remove all occurrences of space duplication
	Do While instr(strNewKeywords, "  ") > 0
		strNewKeywords = Replace(strNewKeywords, "  ", " ")
	Loop
	strNewKeywords = Trim(strNewKeywords)
	
	'Only add keywords up to the max allowed, and trim all to size
	'We need size checks to ensure the query doesn't get too long
	numAppMaxSearchKeywords = GetAppVar("maxsearchkeywords")
	numAppMaxSearchKeywordLength = GetAppVar("maxsearchkeywordlength")
	If strSearchCriteria = "exact" then
		'Treat the whole thing like one keyword
		CleanSearchKeywords = Left(strNewKeywords, numAppMaxSearchKeywordLength)
	Else		
		'Validate each keyword
		aryAllKeywords = Split(strNewKeywords, " ")
		Redim aryNewKeywords(Min(ubound(aryAllKeywords), numAppMaxSearchKeywords - 1))
		For numCount = 0 to ubound(aryNewKeywords)
			aryNewKeywords(numCount) = Left(aryAllKeywords(numCount), numAppMaxSearchKeywordLength)
		Next
		CleanSearchKeywords = Join(aryNewKeywords, " ")
	End If
	
End Function

'-----------------------------------------------
'CREATE KEYWORD ARRAY
'Set the keywords array. If we're doing an exact,
'then it's a one bound array. If we have no 
'keywords, then it's a one-bound blank array. 
'Otherwise it has bound for each word.
'-----------------------------------------------
Function CreateKeywordArray(strKeywords, strSearchCriteria)
	If strKeywords = "" then 
		'Splitting a blank string doesn't return an array
		ReDim aryNewKeywords(0)
		aryNewKeywords(0) = ""
		
	ElseIf strSearchCriteria = "exact" then
		'put it all in one bound
		ReDim aryNewKeywords(0)
		aryNewKeywords(0) = strKeywords

	Else
		'Split by a space
		aryNewKeywords = Split(strKeywords, " ")
		
	End If
	CreateKeywordArray = aryNewKeywords
End Function
'***********************************************


'***********************************************
'CACTUSHOP-SPECIFIC FUNCTIONS
'Specific functions useful in one or more places
'in the cactushop software
'***********************************************
'-----------------------------------------------
'ADD TO MAILING LIST
'This function adds the passed email address to
'the mailing list database. It then sends a
'confirmation email to the user that they need
'to click on to authorize themselves. It 
'returns and error message if it fails
'-----------------------------------------------
Function AddToMailingList(strEmailAddress, blnHTML, objRS)
Dim strBodyText	
	'Check whether they already exist
	strQuery = "SELECT COUNT(*) FROM tblCactuShop" & TABLE_PREFIX & "Customers WHERE C_EmailAddress=" & strUnicode & "'" & SQLSafe(strEmailAddress) & "' AND C_ML_ConfirmationDateTime>" & strDateDelimiter & ReverseDate("1/1/1900") & strDateDelimiter
	If clng(ExecuteScalar(strQuery)) > 0 then
		AddToMailingList = CreateError(GetString("ContentText_EmailAlreadySignedUp"))
	Else

		'There are two possibilities
		'1. They have an account but it is currently set to NOT be on mailing list
		'- In this case, we adjust existing record and add signup info, try to get confirmation
		'2. They don't have an account yet
		'- In this case, we create the account and try to get confirmation
		numPasswordLength = GetAppVar("minimumcustomercodesize")
		If numPasswordLength = 0 then numPasswordLength = 8
		C_ML_RandomKey = GetRandomString(numPasswordLength) 'this key is used later to validate confirmation - only the address owner will receive this

		strQuery = "SELECT COUNT(*) FROM tblCactuShop" & TABLE_PREFIX & "Customers WHERE C_EmailAddress='" & SQLSafe(strEmailAddress) & "'"
		If clng(ExecuteScalar(strQuery)) > 0 then

			'1. They have account so we need to do UPDATE query
			strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "Customers SET " &_
			"C_EmailAddress=" & strUnicode & "'" & SQLSafe(strEmailAddress) & "', " &_
			"C_ML_SignupDateTime=" & strDateDelimiter & ReverseDate(NowOffset) & strDateDelimiter & ", " &_
			"C_ML_SignupIP='" & objCactuSession.IP & "', " &_
			"C_ML_RandomKey=" & strUnicode & "'" & C_ML_RandomKey & "', " &_
			"C_ML_Format='" & IIf(blnHTML, "h", "t") & "', " &_
			"C_LanguageID=" & NumSafe(numLanguageID) & " WHERE C_EmailAddress=" & strUnicode & "'" & SQLSafe(strEmailAddress) & "'"

		Else

			'2. No account - create one with an INSERT
			strQuery = "INSERT INTO tblCactuShop" & TABLE_PREFIX & "Customers (C_EmailAddress, C_Password, C_ML_SignupDateTime, C_ML_SignupIP, C_ML_RandomKey, C_ML_Format, C_LanguageID) VALUES (" & strUnicode & "'" & SQLSafe(strEmailAddress) & "', " & strUnicode & "'" & SQLSafe(C_ML_RandomKey) & "', " & strDateDelimiter & ReverseDate(NowOffset) & strDateDelimiter & ", '" & objCactuSession.IP & "', " & strUnicode & "'" & SQLSafe(C_ML_RandomKey) & "', '" & IIf(blnHTML, "h", "t") & "'," & CInt(numLanguageID) & ")"

		End if


		Call ExecuteNonQuery(strQuery)
		
		'Get the ID
		C_ID = 0
		strQuery = LimitSQL("C_ID FROM tblCactuShop" & TABLE_PREFIX & "Customers WHERE C_EmailAddress=" & strUnicode & "'" & SQLSafe(strEmailAddress) & "' AND C_ML_RandomKey=" & strUnicode & "'" & SQLSafe(C_ML_RandomKey) & "'" , 1, false)
		Do While C_ID = 0
			Call ExecuteRS(strQuery, objRecordSet)
			if not (objRecordSet.bof and objRecordSet.eof) then
				C_ID = objRecordSet("C_ID")
			end if
			objRecordSet.close
		loop
		
		'Send email to signup
		strBodyText = GetString("EmailText_NewsletterSignup") & vbcrlf & vbcrlf &_
					  "xxxWEBSHOPURLxxxa.asp?id=" & C_ID & "&r=" & C_ML_RandomKey & vbcrlf & vbcrlf &_
					  GetString("EmailText_NewsletterAuthorizeFooter")
		strBodyText = replace(strBodyText, "xxxIPADDRESSxxx", objCactuSession.IP)
		strBodyText = replace(strBodyText, "xxxWEBSHOPNAMExxx", GetString("Config_Webshopname"))
		strBodyText = replace(strBodyText, "xxxWEBSHOPURLxxx", GetAppVar("webshopurl"))
		Call SendEMail(GetAppVar("emailmethod"), GetAppVar("mailserver"), strEmailAddress, "", "", strEmailFrom, GetString("Config_OwnerName"), strEmailFrom, GetString("Config_OwnerName"), GetString("Config_Subjectline3"), strBodyText, "", false)
	End If
	
End Function

'-----------------------------------------------
'CLEAN CARD NUMBER
'Removes any oft-used characters from a
'credit card number
'-----------------------------------------------
Function CleanCardNumber(strCreditCard)
	If strCreditCard <> "" then
		strCreditCard = replace(strCreditCard, " ", "")
		strCreditCard = replace(strCreditCard, "/", "")
		strCreditCard = replace(strCreditCard, "-", "")
		strCreditCard = replace(strCreditCard, ".", "")
	End if
	CleanCardNumber = strCreditCard	
End Function

'-----------------------------------------------
'LUHNCHECK TO PRE-CHECK CREDIT CARD NUMBER		
'A Luhncheck will only determine is a credit	
'card number is of the correct format. It will	
'not detect fraudulent use of cards or any other
'such errors or misuse. There is a switch in the
'config settings. This way you can bang in random
'numbers during testing and not keep getting	
'errors.
'-----------------------------------------------
Function LuhnCheck(strCreditCard)
	strCard = CleanCardNumber(strCreditCard)
	if NumSafe(strCard) = 0 then
		LuhnCheck = false
	else
		numLength = len(strCard)
		For numPlace = 0 to numLength - 1
			strRealPlace = numLength - numPlace
			if numPlace mod 2 <> 0 then 
				numTempValue = Mid(strCard, strRealPlace, 1) * 2 
			else 
				numTempValue = Mid(strCard, strRealPlace, 1)
			end if
			strNewString = strNewString & numTempValue
		Next
		numTempValue = 0
		numLength = len(strNewString)
		For numPlace = 1 to numLength
			numTempValue = numTempValue + Mid(strNewString, numPlace, 1)
		Next
		if (numTempValue mod 10) = 0 then LuhnCheck = true else LuhnCheck = false
	end if
End Function

'-----------------------------------------------
'GET COUNTRY STRING
'Accepts the ID of the destination record and
'the language (plus db connection info), 
'and returns the destination name
'-----------------------------------------------
Function GetCountryString(numID, numLanguage)
	'Pull out the country name
	Set objRecordSetCountry = Server.CreateObject("ADODB.Recordset")
	strQuery = "SELECT D_Destination" & CStr(numLanguage) & " FROM tblCactuShop" & TABLE_PREFIX & "Destination WHERE D_ID = " & numID
	Call ExecuteRS(strQuery, objRecordSetCountry)
	strCountry = objRecordSetCountry("D_Destination" & CStr(numLanguage))
	objRecordSetCountry.Close
	Set objRecordSetCountry = nothing
	
	'And return it
	GetCountryString = strCountry
End Function


'-----------------------------------------------
'ADD TO RECENT PRODUCTS / GET RECENT PRODUCTS
'Note that we don't limit the array to the 
'"recentproducts"
'-----------------------------------------------
Sub SaveToRecentProducts(strID)
	numID = NumSafe(strID)
	If numID > 0 then
		
		'Get the recent products list - note that we set a large max - we
		'dont want to use the config setting because some may be removed
		'later on in the SQL query, and we still want up to a possible 5.
		numAppRecentProducts = GetAppVar("recentproducts")
		strRecentProducts = "," & GetRecentProducts(50, 0) & ","
		If strRecentProducts = ",," then strRecentProducts = ","
		
		'If it's already in it - remove it so it goes to the start
		If instr(strRecentProducts, "," & numID & ",") > 0 then
			strRecentProducts = Replace(strRecentProducts, "," & numID & ",", ",")
		End If
		
		'Add it on to the front of the list and save to cactusession, triming the trailing ,
		strRecentProducts = left(strRecentProducts, len(strRecentProducts) - 1)
		strRecentProducts = numID & strRecentProducts
		objCactuSession.Edit "recentproducts", strRecentProducts
	end if
End Sub

'Get the products, check validity, and return a comma-delimited string.
'Optionally pass an ID to exclude. 
Function GetRecentProducts(numMax, numExclude)
	aryRecentProducts = Split(objCactuSession.Value("recentproducts"), ",")
	For Each strRecentProduct in aryRecentProducts
		numRecentProduct = NumSafe(strRecentProduct)
		If numRecentProduct > 0 and Occurrences(strRecentProducts, ",") + 1 < numMax and numRecentProduct <> numExclude then
			strRecentProducts = IIf(strRecentProducts = "", numRecentProduct, strRecentProducts & "," & numRecentProduct)
		End If
	Next
	GetRecentProducts = strRecentProducts
End Function

'-----------------------------------------------
'ADMIN LOG
'Lots an event - such as a config or language-
'string change - to the database
'-----------------------------------------------
Function AdminLog(AL_Type, AL_Description, AL_Query, AL_RelatedID)
	AL_DateStamp = NowOffset()
	AL_LoginID = numThisUserLOGIN_ID
	strQuery = "INSERT INTO tblCactuShop" & TABLE_PREFIX & "AdminLog (AL_DateStamp, AL_LoginID, AL_Type, AL_Description, AL_Query, AL_RelatedID, AL_IP) VALUES (" & strDateDelimiter & ReverseDate(AL_DateStamp) & strDateDelimiter & "," & NumSafe(AL_LoginID) & ",'" & SQLSafe(AL_Type) & "'," & strUnicode & "'" & SQLSafe(AL_Description) & "'," & strUnicode & "'" & SQLSafe(AL_Query) & "','" & SQLSafe(AL_RelatedID) & "', '" & request.ServerVariables("REMOTE_ADDR") & "')"
	Call ExecuteNonQuery(strQuery)
End Function	

'-----------------------------------------------
'LOG SALE
'Lots a version sale. Only do this if tracking
'is turned on
'-----------------------------------------------
Function LogSale(numVersionID, numQuantity)
	if GetAppVar("trackingsales") = "y" then
		strQuery = "INSERT INTO tblCactuShop" & TABLE_PREFIX & "VersionSalesStats (VSS_VersionID, VSS_Quantity, VSS_Date, VSS_IP) VALUES (" & _
			NumSafe(numVersionID) & "," & _
			NumSafe(numQuantity) & "," &_
			strDateDelimiter & ReverseDate(NowOffset()) & strDateDelimiter & "," &_
			"'" & SQLSafe(objCactuSession.IP) & "')"
		Call ExecuteNonQuery(strQuery)
	End if
End Function


'-----------------------------------------------
'UPDATE PRODUCT AVERAGE
'This updates the static product customer rating
'average.
'-----------------------------------------------
Sub UpdateProductAverage(numProductID)
	strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "Products SET P_AverageRating = " & GetProductAverage(numProductID) & " WHERE P_ID = " & NumSafe(numProductID)
	Call ExecuteNonQuery(strQuery)
End Sub


Function GetProductAverage(numProductID)
	strQuery = "SELECT Round(SUM(REV_Rating) / COUNT(*), 1) As AverageRating FROM tblCactuShop" & TABLE_PREFIX & "Reviews WHERE REV_ProductID = " & numProductID & " AND REV_Rating > 0 AND REV_Live = 'y'"
	GetProductAverage = NearestHalfInteger(NumSafe(ExecuteScalar(strQuery)))
End Function

'Founds a value to the nearest half - e.g. 0, 0.5, 1, etc
Function NearestHalfInteger(numValue)
	numMainPart = Int(numValue)
	numFractionalPart = numValue - numMainPart
	If numFractionalPart < 0.25 then
		numNewFractionalPart = 0
	ElseIf numFractionalPart < 0.75 then
		numNewFractionalPart = 0.5
	Else
		numNewFractionalPart = 1
	End If
	NearestHalfInteger = numMainPart + numNewFractionalPart
End Function

'-----------------------------------------------
'GET COUNTRY CODE
'-----------------------------------------------
Function GetCountryCode(numShippingCountry)
	strQuery = "SELECT D_ISOCode FROM tblCactuShop" & TABLE_PREFIX & "Destination WHERE D_ID=" & NumSafe(numShippingCountry)
	Call ExecuteRS(strQuery, objRecordSet)
	If not (objRecordSet.BOF and objRecordSet.EOF) Then
		GetCountryCode = objRecordSet("D_ISOCode")
	end if
	objRecordSet.Close
End Function


'GET KB REDIRECT
'Returns the URL to redirect to the knowledgebase

Function GetRedirect(strID)
	GetRedirect = "http://www.cactushop.com/requests/redirect/?t=" & strID
End Function


'***********************************************


'***********************************************
'NEW ERROR CHECKING FUNCTIONS
'Validates data
'***********************************************
'Create a formatted error
Function CreateError(strError)
	CreateError = "<li>" & strError & "</li>" & vbcrlf
End Function

'Create a label
Function CreateLabel(strName, strLabel)
	CreateLabel = "<label for=""" & strLabel & """>" & strName & "</label>"
End Function

'Create error with token in language string
Function CreateErrorWithLabel(strError, strName, strLabel)
	CreateErrorWithLabel = CreateError(Replace(strError, "<label>", CreateLabel(strName, strLabel)))
End Function

'Format the errors in a list
Function FormatErrors(strErrors)
	If Len(strErrors) > 0 then
		FormatErrors = "<ol>" & strErrors & "</ol>"
	End If
End Function

'Check field is not blank (LS: 260)
Function CheckBlank(strName, strValue, strLabel)
	If strValue = "" then 
		CheckBlank = CreateError(CreateLabel(strName, strLabel) & " " & GetString("ContentText_IsBlank") & ".")
	End If
End Function

'-----------------------------------------------
'CHECK FIELD IS NOT ZERO
'-----------------------------------------------
Function CheckZero(strName, strValue, strLabel)
	If strValue = 0 then 
		CheckZero = CreateError(CreateLabel(strName, strLabel) & " " & GetString("ContentText_IsBlank") & ".")
	End If
End Function

'-----------------------------------------------
'CHECK LENGTH (LS: 258, 259)
'-----------------------------------------------
Function CheckLength(strName, strValue, numMax, strLabel)
	If len(strValue) > numMax then 
		CheckLength = CreateError(CreateLabel(strName, strLabel) & " " & GetString("ContentText_IsCurrently") & " " & len(strValue) & " " & GetString("ContentText_ButMustBeLessThan") & " " & numMax & ".")
	End If
End Function

'-----------------------------------------------
'CHECK EMAIL ADDRESS IS VALID FORMAT
'-----------------------------------------------
Function CheckEmail(strName, strValue, strLabel)
	If strValue <> "" then
		Dim regEx, retVal
		Set regEx = New RegExp
		regEx.Pattern = "^(([^<>()[\]\\.,;:\s@""]+(\.[^<>()[\]\\.,;:\s@""]+)*)|("".+""))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$"
		regEx.IgnoreCase = true
		blnReturnValue = regEx.Test(strValue)
		If not blnReturnValue Then
			CheckEmail = CreateErrorWithLabel(GetString("ContentText_EmailAddressNotValid") & " " & WriteSafe(strEmailFrom) & ".", strName, strLabel)
		End If
		Set regEx = Nothing
	else
		CheckEmail = CreateErrorWithLabel(GetString("ContentText_NoEmailAddressEntered"), strName, strLabel)
	end if
End Function


'-----------------------------------------------
'ERROR CHECK VAT NUMBER (EU vat numbers)
'We pass it an ISO country code and a VAT number
'Returns whether VAT number is valid format for
'the specified country (LS1130)
'-----------------------------------------------
Function CheckVatNumber(strName, strISOCode, strVatNumber, strLabel)
	strVatNumber = Replace(Replace(strVatNumber, " ", ""), "-", "")
	strVatNumber = Replace(Replace(strVatNumber, ".", ""), ",", "")
	strCountryCodeFromVatNumber = left(strVatNumber, 2)
	numVatNumberLength = Len(strVatNumber) - 2

	Select Case strISOCode	
		Case "AT" 'Austria
			blnPassed = numVatNumberLength = 9 and _
					    Ucase(Mid(strVatNumber, 3, 1)) = "U" and _
						IsNumeric(Right(strVatNumber, 8)) and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "BE","PT","DE","EE" 'Belgium, Portugal, Germany, Estonia
			blnPassed = numVatNumberLength = 9 and _
						IsNumeric(Right(strVatNumber, 9)) and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "DK","FI","LU","MT","HU","SI" 'Denmark, Finland, Luxembourg, Malta, Hungary, Slovenia
			blnPassed = numVatNumberLength = 8 and _
						IsNumeric(Right(strVatNumber, 8)) and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "FR" 'France
			blnPassed = numVatNumberLength = 11 and _
						IsNumeric(Right(strVatNumber, 9)) and _
						InStr(strVatNumber, "O") = 0 and _
						InStr(strVatNumber, "I") = 0 and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "GR" 'Greece
			blnPassed = numVatNumberLength = 9 and _
						IsNumeric(Right(strVatNumber, 9)) and _
						Mid(strVatNumber, 3, 1) = "0" and _
						strCountryCodeFromVatNumber = "EL"
			
		Case "IE" 'Ireland
			blnPassed = numVatNumberLength = 8 and _
						IsNumeric(Mid(strVatNumber, 5, 4)) and _
						Not IsNumeric(Right(strVatNumber, 1)) and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "IT","LV" 'Italy, Latvia
			blnPassed = numVatNumberLength = 11 and _
						IsNumeric(Right(strVatNumber, 11)) and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "NL" 'Netherlands
			blnPassed = numVatNumberLength = 12 and _
						IsNumeric(Right(strVatNumber, 2)) and _
						IsNumeric(Mid(strVatNumber, 3, 8)) and _
						mid(strVatNumber, 12, 1) = "B" and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "ES" 'Spain
			blnPassed = numVatNumberLength = 9 and _
						IsNumeric(Mid(strVatNumber, 4, 7)) and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "SE" 'Sweden
			blnPassed = numVatNumberLength = 12 and _
						IsNumeric(Right(strVatNumber, 12)) and _
						right(strVatNumber, 2) = "01" and _
						strCountryCodeFromVatNumber = strISOCode
			
		Case "UK", "LT" 'United Kingdom, Lithuania
			blnPassed = (numVatNumberLength = 12 or numVatNumberLength = 9) and _
						IsNumeric(Right(strVatNumber, 9)) and _
						(strCountryCodeFromVatNumber = "GB" or strCountryCodeFromVatNumber = "LT")

		Case "CY" 'Cyprus
			blnPassed = numVatNumberLength = 9 and _
						Not IsNumeric(right(strVatNumber, 1)) and _
						strCountryCodeFromVatNumber = strISOCode

		Case "CZ" 'Czech Republic
			If numVatNumberLength >= 11 and numVatNumberLength <= 13 then 
				strVatNumber = mid(strVatNumber, 4)
				numVatNumberLength = len(strVatNumber)
			End If
			blnPassed = numVatNumberLength >= 8 and _
						numVatNumberLength <= 10 and _
						IsNumeric(Right(strVatNumber, 8)) and _
						(strCountryCodeFromVatNumber = "CS" or strCountryCodeFromVatNumber = "CZ")

		Case "PL", "SK" 'Poland, Slovak Republic
			blnPassed = numVatNumberLength = 10 and _
						IsNumeric(Right(strVatNumber, 10)) and _
						strCountryCodeFromVatNumber = strISOCode

		Case Else		'ISO not recognised as in the EU - fail
			blnPassed = false
			
	End Select

	If Not blnPassed Then
		CheckVatNumber = CreateErrorWithLabel(GetString("ContentText_VATNumberInvalid") & ".", strName, strLabel)
	End If
End Function


'***********************************************
'BACKEND CHECKING FUNCTIONS
'***********************************************
'-----------------------------------------------
'CHECK FIELD IS NOT BLANK						
'LS: 260
'-----------------------------------------------
Function BackendCheckBlank(strErrorMsg, numErrorNo, strItemName, strFieldName)
	If strFieldName = "" then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg & "<span class=""bold"">" & CStr(numErrorNo) & ".</span> " & "<span class=""bold"">" & strItemName & "</span> " & GetString("ContentText_IsBlank") & ".<br />"
	End if
	BackendCheckBlank = strErrorMsg
End Function


'-----------------------------------------------
'ERROR CHECK LENGTH OF STRING TO PREVENT
'DATABASE ERRORS FOR OVERSIZED INPUT
'Similar to the above. Access with ODBC seems to
'truncate and not throw errors, but if you go to
'OLE DB or use SQL Server you have to check the
'field lengths to avoid nasty errors.
'LS: 258, 259
'-----------------------------------------------
Function BackendCheckLength(strErrorMsg, numErrorNo, strItemName, strFieldName, numAllowableLength)
	If Len(strFieldName) > numAllowableLength then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg & "<span class=""bold"">" & CStr(numErrorNo) & ".</span> " & "<span class=""bold"">" & strItemName & "</span> " & GetString("ContentText_IsCurrently") & " " & len(strFieldName) & " " & GetString("ContentText_ButMustBeLessThan") & " " & numAllowableLength & ".<br />"
	End if
	BackendCheckLength = strErrorMsg
End Function

'***********************************************





'***********************************************
'FUNCTIONS TO EXECUTE AGAINST THE DATABASE
'***********************************************
'-----------------------------------------------
'Functions called for error reporting
'-----------------------------------------------
Sub ReportQueryError(strQuery, strErrorDescription)
	'Close any tags we may be in
	response.Write "</textarea></select>"
	response.Write "<div style=""width: 80%; font-family:verdana; font-size:12px; font-weight:normal; background-color: #eeeeee; margin: 10pt 10pt 10pt 10pt; padding: 20pt 20pt 20pt 20pt; border: 1pt solid black"">"
	response.Write "<p style=""font-weight: bold"">An error occurred executing the following query, and page execution has been terminated.</p>"
	response.Write "<p style=""font-family:courier new; font-size:14px; color:#800000"">" & strQuery & "</p>"
	response.write "<p><strong>Error Description : </strong> " & strErrorDescription & "</p>"
	response.write "<p><strong>Page of error : </strong> " & Request.ServerVariables("URL") & "</p>"
	response.write "<p><strong>Query String : </strong><br /><br />" & Request.QueryString & "</p>"
	response.Write "</div>"
	Call EndPage()
	response.end
End Sub	

'-----------------------------------------------
'Executes the query, and records the recordset
'filled with the results
'-----------------------------------------------
Sub ExecuteRS(strQuery, objRS)
	'Start error trapping
	if not (blnDoingTransaction or blnDoingCallback) then On Error Resume Next
	
	'Start the timer for query execution
	numStartTime = Timer
	
	'Execute query
	cmdTemp.CommandText = strQuery
	cmdTemp.CommandType = 1
	Set cmdTemp.ActiveConnection = objDataConn
	If strDatabaseType = "mysql" or strDatabaseType = "mssql" Then objRS.CursorLocation = 3
	objRS.Open cmdTemp, , 1, numCursorType
	
	'Increment count and query time
	numQueryExecutionTime = numQueryExecutionTime + (Timer - numStartTime)
	numTotalExecuteRS = numTotalExecuteRS + 1
	strQueryBuildup = strQueryBuildup & "<li>" & WriteSafe(strQuery) & "<br /><em><strong>ExecuteRS - Time: " & Round(Timer - numStartTime, 2) * 100 & "ms</strong></em><br /><br /></li>"
		
	'Report error, end error trapping
	if err.Description <> "" and not blnDoingTransaction then Call ReportQueryError(strQuery, err.Description)
	if not (blnDoingTransaction or blnDoingCallback) then on error goto 0
	
End Sub

'-----------------------------------------------
'Executes a query, and returns the first value
'in the first column of the recordset
'-----------------------------------------------
Function ExecuteScalar(strQuery)
	'Start error trapping
	if not (blnDoingTransaction or blnDoingCallback) then On Error Resume Next
	
	'Start the timer for query execution
	numStartTime = Timer
	
	'Execute query
	ExecuteScalar = objDataConn.Execute(strQuery)(0)
	
	'Increment count and query time 
	numQueryExecutionTime = numQueryExecutionTime + (Timer - numStartTime)
	numTotalExecuteScalar = numTotalExecuteScalar + 1
	strQueryBuildup = strQueryBuildup & "<li>" & WriteSafe(strQuery) & "<br /><em><strong>ExecuteScalar - Time: " & Round(Timer - numStartTime, 2) * 100 & "ms</strong></em><br /><br /></li>"
	
	'Report error, end error trapping
	if err.Description <> "" and not blnDoingTransaction then Call ReportQueryError(strQuery, err.Description)
	if not (blnDoingTransaction or blnDoingCallback) then on error goto 0	
End Function

'-----------------------------------------------
'Executes a non-query - i.e. one that returns
'no results (INSERT, UPDATE)
'-----------------------------------------------
Sub ExecuteNonQuery(strQuery)
	'Start error trapping
	if not (blnDoingTransaction or blnDoingCallback) then On Error Resume Next
	
	'Start the timer for query execution
	numStartTime = Timer
	
	'Execute query
	objDataConn.Execute(strQuery)
	
	'Increment count and query time
	numQueryExecutionTime = numQueryExecutionTime + (Timer - numStartTime)
	numTotalExecuteNonQuery = numTotalExecuteNonQuery + 1
	strQueryBuildup = strQueryBuildup & "<li>" & WriteSafe(strQuery) & "<br /><em><strong>ExecuteNonQuery - Time: " & Round(Timer - numStartTime, 2) * 100 & "ms</strong></em><br /><br /></li>"
	
	'Report error, end error trapping
	if err.Description <> "" and not blnDoingTransaction then Call ReportQueryError(strQuery, err.Description)
	if not (blnDoingTransaction or blnDoingCallback) then on error goto 0	
End Sub
'***********************************************



'***********************************************
'LANGUAGE STRINGING FUNCTIONS
'***********************************************
'-----------------------------------------------
'LOAD LANGUAGE STRINGS FROM DATABASE
'This function is used to return a list of
'values from the database
'It's used so that there is only one
'call to the database rather than many for each
'string that is required on any given page.
'Errors will occur if the IDList string does
'not take the form:
'1, 4, 6, 12, 5
'or:
'1,4,6,12,5
'-----------------------------------------------
Sub LoadStrings(strIDlist, strTableName)
	If strIDlist <> "" Then
		
		strQuery = "SELECT LS_Name, LS_Value FROM " & strTableName & " WHERE LS_ID IN (" & strIDlist & ")"
		call ExecuteRS(strQuery, objRecordSet)
		Do Until objRecordSet.EOF
			If Not IsNull(objRecordSet(0)) Then
				StringDict.Add CStr(lcase(objRecordSet(0) & "")), CStr(objRecordSet(1) & "")
			Else 
				StringDict.Add CStr(lcase(objRecordSet(0))), ""
			End If
			objRecordSet.MoveNext
		Loop
		objRecordSet.Close
	End If
End Sub

'-----------------------------------------------
'LANG STRING GETTING
'Functions to get and write out language strings
'-----------------------------------------------
Sub WriteString(strLanguageStringName)
	Response.Write(StringDict(lcase(strLanguageStringName)))
End Sub
Sub WriteSafeString(strLanguageStringName)
	Response.Write(WriteSafe(StringDict(lcase(strLanguageStringName))))
End Sub
Function GetString(strLanguageStringName)
	GetString = StringDict(lcase(strLanguageStringName))
End Function
Function GetSafeString(strLanguageStringName)
	GetSafeString = WriteSafe(StringDict(lcase(strLanguageStringName)))
End Function

'-----------------------------------------------
'BUILD SINGLE DROPDOWN MENUS WITH LANGUAGE				
'Like singledropdown, but the displayname is language-
'related; it can be suffixed with a number
'relating to the language table. It checks all
'of these for a string that isn't blank, starting
'with the default.
'Before calling this, the recordset must include
'all language IDs
'-----------------------------------------------
Sub SingleDropDownLang(strDropdownName, strFirstLineValue, strFirstLineDisplay, objRS, strValueName, strDisplayName, strSelectedVariable)
	'start up the select string
	strMenuText = ""
	strMenuText = "<select name=""" & strDropdownName & """ id=""" & strDropdownName & """ size=""1"">" & vbcrlf
	
	'if we want a 'SELECT...' type first line, write that in
	If strFirstLineDisplay <> "" then
		strMenuText = strMenuText & "<option value=" & """" & strFirstLineValue & """" & ">" & strFirstLineDisplay & "</option>"&vbcrlf
	end if
	
	'for every record in the passed recordset...
	do while not objRS.EOF
		strSelected = ""
		
		'Check the default language ID
		strValueInDatabase = objRS(strValueName)
		If IsNull(strValueInDatabase) Then strValueInDatabase = ""
		
		strDisplayValueInDatabase = objRS(strDisplayName & CInt(numLanguageID))
		If IsNull(strValueInDatabase) Then strDisplayValueInDatabase = ""

		'if that's blank, then loop through all languages until one is found
		If strDisplayValueInDatabase = "" then 
			For numCount = 1 to numTotalLanguages
				if aryLangLiveBack(numCount) = "y" then
					strDisplayValueInDatabase = objRS(strDisplayName & CStr(numCount))
					If isNull(strDisplayValueInDatabase) then strValueInDatabase = ""
					If strDisplayValueInDatabase <> "" then Exit For
				end if
			next
		end if
		
		'write out the option
		if CStr(strSelectedVariable) = CStr(strValueInDatabase) then strSelected = " selected=""selected"""
		strMenuText = strMenuText & "<option" & strSelected & " value=""" & strValueInDatabase & """>" & strDisplayValueInDatabase & "</option>" & vbcrlf
		objRS.movenext
	loop
	
	'close the select and return the string
	strMenuText = strMenuText & "</select>"
	response.write(strMenuText)
End Sub

'-----------------------------------------------
'GET TRANSLATION
'Returns the first translation that exists for
'a field (e.g. P_Name). First it tries the 
'current language - if that's no good, it cycles
'through all languages till it finds a good'en)
'-----------------------------------------------
Function GetTranslation(objRS, strFieldName)
	on error resume next
	GetTranslation = objRS(strFieldName & CInt(numLanguageID))
	if err.Description <> "" then
		response.Write "error trying to get field " & strFieldName & CInt(numLanguageID)
		response.End 
	end if
	on error goto 0
	If GetTranslation & "" = "" then
		for numCount = 1 to numTotalLanguages
			GetTranslation = objRS(strFieldName & CStr(numCount))
			If GetTranslation & "" <> "" then exit for
		next
	end if
End Function


'-----------------------------------------------
'CREATE ADMIN BAR
'Do this with sub so can use on front and back
'end pages in different ways.
'-----------------------------------------------
Sub CreateAdminBar(strAdminBarHTML)

	strAdminBarHTML = strAdminBarHTML & ("<div id=""adminbar"" title=""" & GetString("ContentText_CactuShopVersion") & " v" & CACTUSHOPVERSION & " 1999-2008 Cactusoft International FZ-LLC."">" & vbcrlf)

	strAdminBarHTML = strAdminBarHTML & ("<div><div id=""col1"">" & vbcrlf)
	If strThisUserLOGIN_Config = "y" then
		Select Case GetAppVar("shopstatus")
	
		Case "locked"
			strAdminBarHTML = strAdminBarHTML & ("<a class=""shopstatus state2"" title=""" & GetSafeString("ContentText_HardCloseTheShop") & """ href=""" & strTemplateShopFolder & "_update_lockshop.asp?" & objCactuSession.QS & "lockshopstatus=hardlock"">" & GetSafeString("ContentText_TheShopIsClosed") & "</a>" & vbcrlf)
	
		Case "hardlocked"
			strAdminBarHTML = strAdminBarHTML & ("<a class=""shopstatus state3"" title=""" & GetSafeString("ContentText_OpenTheShop") & """ href=""" & strTemplateShopFolder & "_update_lockshop.asp?" & objCactuSession.QS & "lockshopstatus=open"">" & GetSafeString("ContentText_TheShopIsHardClosed") & "</a>" & vbcrlf)
	
		Case Else
			'Wow, guess it must be open for business
			strAdminBarHTML = strAdminBarHTML & ("<a class=""shopstatus state1"" title=""" & GetSafeString("ContentText_CloseTheShop") & """ href=""" & strTemplateShopFolder & "_update_lockshop.asp?" & objCactuSession.QS & "lockshopstatus=lock"">" & GetSafeString("ContentText_TheShopIsOpen") & "</a>" & vbcrlf)
	
		
		End Select
	End if
	strAdminBarHTML = strAdminBarHTML & ("<strong>" & strThisUserLOGIN_Username & "</strong>" & vbcrlf)
	strAdminBarHTML = strAdminBarHTML & ("<img src=""" & strTemplateShopFolder & "images/tick" & IIf(strThisUserLOGIN_Orders = "y", "", "_empty") & ".gif"" alt=""" & GetSafeString("ImageLabel_PermOrders") & """ title=""" & GetSafeString("ImageLabel_PermOrders") & """ />&nbsp;")
	strAdminBarHTML = strAdminBarHTML & ("<img src=""" & strTemplateShopFolder & "images/tick" & IIf(strThisUserLOGIN_Products = "y", "", "_empty") & ".gif"" alt=""" & GetSafeString("ImageLabel_PermProducts") & """ title=""" & GetSafeString("ImageLabel_PermProducts") & """ />&nbsp;")
	strAdminBarHTML = strAdminBarHTML & ("<img src=""" & strTemplateShopFolder & "images/tick" & IIf(strThisUserLOGIN_Config = "y", "", "_empty") & ".gif"" alt=""" & GetSafeString("ImageLabel_PermConfig") & """ title=""" & GetSafeString("ImageLabel_PermConfig") & """ />&nbsp;")



	strAdminBarHTML = strAdminBarHTML & ("</div>" & vbcrlf)

	strAdminBarHTML = strAdminBarHTML & ("<div id=""col2"">" & vbcrlf)

	strAdminBarHTML = strAdminBarHTML & ("<div class=""adminbuttonrow"">")

	strAdminBarHTML = strAdminBarHTML & ("<a title=""" & GetSafeString("BackMenu_Front") & """ href=""" & strTemplateShopFolder & "default.asp?" & objCactuSession.QS & """>" & GetSafeString("BackMenu_Front") & "</a>" & vbcrlf)
	strAdminBarHTML = strAdminBarHTML & ("<a title=""" & GetSafeString("AdminBar_ViewBackend") & """ href=""" & strTemplateShopFolder & "_default.asp?" & objCactuSession.QS & """>" & GetSafeString("AdminBar_ViewBackend") & "</a>" & vbcrlf)

	strAdminBarHTML = strAdminBarHTML & ("<a title=""" & GetSafeString("FormButton_Logout") & """" & IIf(strThisUserLOGIN_UserName = "", " disabled=""disabled""", "") & " href=""" & strTemplateShopFolder & "_logout.asp?" & objCactuSession.QS & """>" & GetSafeString("FormButton_Logout") & "</a>" & vbcrlf)
	strAdminBarHTML = strAdminBarHTML & ("<a title=""" & GetSafeString("FormButton_Help") & """ href=""" & GetRedirect("kb") & """>" & GetSafeString("FormButton_Help") & "</a>" & vbcrlf)

	strPage = request.ServerVariables("PATH_INFO")
	intLastSlash = instrrev(strPage, "/")
	if intLastSlash > 0 then strScriptName = mid(strPage, intLastSlash + 1)
	Select Case strScriptName
		Case "default.asp"
			strAdminBarHTML = strAdminBarHTML & "<a title=""" & GetString("AdminBar_ModifyNews") & """ href=""" & strTemplateShopFolder & "_modify_news.asp?" & objCactuSession.QS & """>" & GetString("AdminBar_ModifyNews") & "</a>" & vbcrlf
		
		Case "product.asp"
			strAdminBarHTML = strAdminBarHTML & "<a title=""" & GetString("AdminBar_ModifyProduct") & """ href=""" & strTemplateShopFolder & "_modify_product.asp?" & objCactuSession.QS & "P_ID=" & P_ID & """>" & GetString("AdminBar_ModifyProduct") & "</a>" & vbcrlf
				
		Case "prodtype.asp"
			If NumSafe(CAT_ID) > 0 then
				strAdminBarHTML = strAdminBarHTML & "<a title=""" & GetString("AdminBar_ModifyCategory") & """ href=""" & strTemplateShopFolder & "_modify_prodtype.asp?" & objCactuSession.QS & "CAT_ID=" & CAT_ID & """>" & GetString("AdminBar_ModifyCategory") & "</a>" & vbcrlf
			end if
		
		Case "page.asp"
			If PAGE_ID <> "" then
				strAdminBarHTML = strAdminBarHTML & "<a title=""" & GetString("AdminBar_ModifyPage") & """ href=""" & strTemplateShopFolder & "_modify_page.asp?" & objCactuSession.QS & "PAGE_ID=" & PAGE_ID & """>" & GetString("AdminBar_ModifyPage") & "</a>" & vbcrlf
			end if
			
	End Select
	
	strAdminBarHTML = strAdminBarHTML & ("</div>" & vbcrlf)
	strAdminBarHTML = strAdminBarHTML & ("</div></div>" & vbcrlf)
	strAdminBarHTML = strAdminBarHTML & ("</div>" & vbcrlf)
			
End Sub
%>

